Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ILayoutEngine.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ILayoutEngine.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ILayoutEngine.cs	(revision 11009)
@@ -1,6 +1,26 @@
-﻿
-using System;
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
 using System.Collections.Generic;
-using System.Drawing;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
@@ -11,17 +31,5 @@
     int VerticalSpacing { get; set; }
 
-    void CalculateLayout();
-    void CalculateLayout(float width, float height);
-    void Initialize(T root, Func<T, IEnumerable<T>> getChildren, Func<T, int> getLength = null, Func<T, int> getDepth = null);
-    void Clear();
-    void Reset();
-
-    // function members necessary to navigate the tree structure
-    Func<T, IEnumerable<T>> GetChildren { get; set; }
-    Func<T, int> GetLength { get; set; }
-    Func<T, int> GetDepth { get; set; }
-
-    IEnumerable<VisualTreeNode<T>> GetVisualNodes();
-    Dictionary<T, PointF> GetCoordinates();
+    IEnumerable<VisualTreeNode<T>> CalculateLayout(T root, float width, float height);
   }
 }
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/LayoutNode.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/LayoutNode.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/LayoutNode.cs	(revision 11009)
@@ -25,5 +25,5 @@
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
-  public class LayoutNode<T> : object where T : class {
+  internal class LayoutNode<T> : object where T : class {
     public float Width { get; set; }
     public float Height { get; set; }
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ReingoldTilfordLayoutEngine.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ReingoldTilfordLayoutEngine.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/LayoutEngines/ReingoldTilfordLayoutEngine.cs	(revision 11009)
@@ -7,5 +7,4 @@
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
   public class ReingoldTilfordLayoutEngine<T> : ILayoutEngine<T> where T : class {
-    private readonly Dictionary<T, LayoutNode<T>> nodeMap; // provides a reverse mapping T => LayoutNode
     public int NodeWidth { get; set; }
     public int NodeHeight { get; set; }
@@ -22,29 +21,38 @@
     }
 
-    public Func<T, IEnumerable<T>> GetChildren { get; set; }
-    public Func<T, int> GetLength { get; set; }
-    public Func<T, int> GetDepth { get; set; }
-    private LayoutNode<T> layoutRoot;
-
-    public ReingoldTilfordLayoutEngine() {
-      nodeMap = new Dictionary<T, LayoutNode<T>>();
-    }
-
-    public ReingoldTilfordLayoutEngine(T root, Func<T, IEnumerable<T>> childrenFunc)
-      : this() {
-      Initialize(root, childrenFunc);
-    }
-
-    public void Initialize(T root, Func<T, IEnumerable<T>> getChildren, Func<T, int> getLength = null, Func<T, int> getDepth = null) {
-      GetChildren = getChildren;
-      Clear();
-      var node = new LayoutNode<T> { Content = root, Width = NodeWidth, Height = NodeHeight };
-      node.Ancestor = node;
-      layoutRoot = node;
-      Expand(node);
-    }
-
-    private void Expand(LayoutNode<T> lRoot) {
-      nodeMap.Add(lRoot.Content, lRoot);
+    private readonly Func<T, IEnumerable<T>> GetChildren;
+
+    public ReingoldTilfordLayoutEngine(Func<T, IEnumerable<T>> GetChildren) {
+      this.GetChildren = GetChildren;
+    }
+
+    public IEnumerable<VisualTreeNode<T>> CalculateLayout(T root) {
+      return CalculateLayout(root, 0, 0);
+    }
+
+    public IEnumerable<VisualTreeNode<T>> CalculateLayout(T root, float width, float height) {
+      Dictionary<T, LayoutNode<T>> layoutNodeMap = new Dictionary<T, LayoutNode<T>>();
+      var layoutRoot = new LayoutNode<T> { Content = root, Width = NodeWidth, Height = NodeHeight, };
+      layoutRoot.Ancestor = layoutRoot;
+      Expand(layoutRoot, layoutNodeMap);
+
+      FirstWalk(layoutRoot);
+      SecondWalk(layoutRoot, -layoutRoot.Prelim);
+      NormalizeCoordinates(layoutNodeMap.Values);
+      if (height != 0 && width != 0) {
+        FitToBounds(width, height, layoutNodeMap.Values);
+        Center(width, height, layoutNodeMap.Values);
+      }
+
+      return layoutNodeMap.Values.Select(x => new VisualTreeNode<T>(x.Content) {
+        Width = (int)Math.Round(x.Width),
+        Height = (int)Math.Round(x.Height),
+        X = (int)Math.Round(x.X),
+        Y = (int)Math.Round(x.Y)
+      });
+    }
+
+    private void Expand(LayoutNode<T> lRoot, Dictionary<T, LayoutNode<T>> map) {
+      map.Add(lRoot.Content, lRoot);
       var children = GetChildren(lRoot.Content).ToList();
       if (!children.Any()) return;
@@ -61,59 +69,13 @@
         node.Ancestor = node;
         lRoot.Children.Add(node);
-        Expand(node);
-      }
-    }
-
-    public IEnumerable<VisualTreeNode<T>> GetVisualNodes() {
-      return nodeMap.Values.Select(x => new VisualTreeNode<T>(x.Content) {
-        Width = (int)Math.Round(x.Width),
-        Height = (int)Math.Round(x.Height),
-        X = (int)Math.Round(x.X),
-        Y = (int)Math.Round(x.Y)
-      });
-    }
-
-    public IEnumerable<LayoutNode<T>> GetLayoutNodes() {
-      return nodeMap.Values;
-    }
-
-    public void AddNode(T content) {
-      if (nodeMap.ContainsKey(content)) { throw new ArgumentException("Content already present in the dictionary."); }
-      var node = new LayoutNode<T> { Content = content };
-      nodeMap.Add(content, node);
-    }
-
-    public void AddNode(LayoutNode<T> node) {
-      var content = node.Content;
-      if (nodeMap.ContainsKey(content)) { throw new ArgumentException("Content already present in the dictionary."); }
-      nodeMap.Add(content, node);
-    }
-
-    public void AddNodes(IEnumerable<LayoutNode<T>> nodes) {
-      foreach (var node in nodes)
-        nodeMap.Add(node.Content, node);
-    }
-
-    public LayoutNode<T> GetNode(T content) {
-      LayoutNode<T> layoutNode;
-      nodeMap.TryGetValue(content, out layoutNode);
-      return layoutNode;
-    }
-
-    public void ResetCoordinates() {
-      foreach (var node in nodeMap.Values) {
-        node.ResetCoordinates();
-      }
-    }
-
-    public Dictionary<T, PointF> GetCoordinates() {
-      return nodeMap.ToDictionary(x => x.Key, x => new PointF(x.Value.X, x.Value.Y));
-    }
+        Expand(node, map);
+      }
+    }
+
 
     /// <summary>
     /// Transform LayoutNode coordinates so that all coordinates are positive and start from (0,0)
     /// </summary>
-    private void NormalizeCoordinates() {
-      var nodes = nodeMap.Values.ToList();
+    private static void NormalizeCoordinates(IEnumerable<LayoutNode<T>> nodes) {
       float xmin = 0, ymin = 0;
       foreach (var node in nodes) {
@@ -127,15 +89,15 @@
     }
 
-    public void Center(float width, float height) {
+    private void Center(float width, float height, IEnumerable<LayoutNode<T>> nodes) {
       // center layout on screen
-      var bounds = Bounds();
+      var bounds = Bounds(nodes);
       float dx = 0, dy = 0;
       if (width > bounds.Width) { dx = (width - bounds.Width) / 2f; }
       if (height > bounds.Height) { dy = (height - bounds.Height) / 2f; }
-      foreach (var node in nodeMap.Values) { node.Translate(dx, dy); }
-    }
-
-    public void FitToBounds(float width, float height) {
-      var bounds = Bounds();
+      foreach (var node in nodes) { node.Translate(dx, dy); }
+    }
+
+    private void FitToBounds(float width, float height, IEnumerable<LayoutNode<T>> nodes) {
+      var bounds = Bounds(nodes);
       var myWidth = bounds.Width;
       var myHeight = bounds.Height;
@@ -143,5 +105,5 @@
       if (myWidth <= width && myHeight <= height) return; // no need to fit since we are within bounds
 
-      var layers = nodeMap.Values.GroupBy(node => node.Level, node => node).ToList();
+      var layers = nodes.GroupBy(node => node.Level, node => node).ToList();
 
       if (myWidth > width) {
@@ -154,9 +116,9 @@
         float spacing = minHorizontalSpacing * x;
         foreach (var layer in layers) {
-          var nodes = layer.ToList();
+          var nodesLayer = layer.ToList();
           float minWidth = float.MaxValue;
-          for (int i = 0; i < nodes.Count - 1; ++i) { minWidth = Math.Min(minWidth, nodes[i + 1].X - nodes[i].X); }
+          for (int i = 0; i < nodesLayer.Count - 1; ++i) { minWidth = Math.Min(minWidth, nodesLayer[i + 1].X - nodesLayer[i].X); }
           float w = Math.Min(NodeWidth, minWidth - spacing);
-          foreach (var node in nodes) {
+          foreach (var node in nodesLayer) {
             node.X += (node.Width - w) / 2f;
             node.Width = w;
@@ -182,29 +144,4 @@
     }
 
-    public void Clear() {
-      layoutRoot = null;
-      nodeMap.Clear();
-    }
-
-    public void Reset() {
-      foreach (var layoutNode in nodeMap.Values) {
-        // reset layout-related parameters 
-        layoutNode.Reset();
-      }
-    }
-
-    public void CalculateLayout() {
-      if (layoutRoot == null) throw new Exception("Layout layoutRoot cannot be null.");
-      Reset(); // reset node parameters like Mod, Shift etc. and set coordinates to 0
-      FirstWalk(layoutRoot);
-      SecondWalk(layoutRoot, -layoutRoot.Prelim);
-      NormalizeCoordinates();
-    }
-
-    public void CalculateLayout(float width, float height) {
-      CalculateLayout();
-      FitToBounds(width, height);
-      Center(width, height);
-    }
 
     /// <summary>
@@ -212,8 +149,7 @@
     /// </summary>
     /// <returns></returns>
-    public RectangleF Bounds() {
+    private RectangleF Bounds(IEnumerable<LayoutNode<T>> nodes) {
       float xmin = 0, xmax = 0, ymin = 0, ymax = 0;
-      var list = nodeMap.Values.ToList();
-      foreach (LayoutNode<T> node in list) {
+      foreach (LayoutNode<T> node in nodes) {
         float x = node.X, y = node.Y;
         if (xmin > x) xmin = x;
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarAllowedChildSymbolsControl.cs	(revision 11009)
@@ -105,5 +105,4 @@
 
       var tree = new SymbolicExpressionTree(new SymbolicExpressionTreeNode(Symbol));
-      symbolicExpressionTreeChart.SuspendRepaint = true;
       if (Grammar.GetMaximumSubtreeCount(Symbol) > 0) {
         for (int i = 0; i < Grammar.GetMaximumSubtreeCount(Symbol); i++) {
@@ -118,5 +117,5 @@
       }
       symbolicExpressionTreeChart.Tree = tree;
-
+      symbolicExpressionTreeChart.SuspendRepaint = true;
       foreach (var subtreeNode in tree.Root.Subtrees) {
         foreach (var allowedChildNode in subtreeNode.Subtrees) {
@@ -144,5 +143,4 @@
         }
       }
-
       symbolicExpressionTreeChart.SuspendRepaint = false;
       UpdateSelectedSymbolicExpressionTreeNodes();
@@ -155,5 +153,5 @@
         else visualNode.FillColor = Color.LightSteelBlue;
       }
-      symbolicExpressionTreeChart.Repaint();
+      symbolicExpressionTreeChart.RepaintNodes();
     }
 
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarSampleExpressionTreeView.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarSampleExpressionTreeView.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionGrammarSampleExpressionTreeView.cs	(revision 11009)
@@ -42,5 +42,5 @@
         treeCreatorComboBox.Items.Add(treeCreator);
       }
-      treeCreatorComboBox.SelectedIndex = 0;
+      treeCreatorComboBox.SelectedItem = treeCreatorComboBox.Items.OfType<ProbabilisticTreeCreator>().First();
     }
 
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 11009)
@@ -27,5 +27,5 @@
 using System.Linq;
 using System.Windows.Forms;
-using Point = System.Drawing.Point;
+
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
@@ -39,6 +39,6 @@
     private const int preferredNodeWidth = 70;
     private const int preferredNodeHeight = 46;
-    private const int minHorizontalDistance = 30;
-    private const int minVerticalDistance = 30;
+    private int minHorizontalDistance = 30;
+    private int minVerticalDistance = 30;
 
     public SymbolicExpressionTreeChart() {
@@ -50,5 +50,9 @@
       this.backgroundColor = Color.White;
       this.textFont = new Font(FontFamily.GenericSansSerif, 12);
-      layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode> {
+
+      visualTreeNodes = new Dictionary<ISymbolicExpressionTreeNode, VisualTreeNode<ISymbolicExpressionTreeNode>>();
+      visualLines = new Dictionary<Tuple<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>, VisualTreeNodeConnection>();
+
+      layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees) {
         NodeWidth = preferredNodeWidth,
         NodeHeight = preferredNodeHeight,
@@ -56,4 +60,5 @@
         VerticalSpacing = minVerticalDistance
       };
+      reingoldTilfordToolStripMenuItem.Checked = true;
     }
 
@@ -105,9 +110,5 @@
       set {
         tree = value;
-        if (tree != null) {
-          //the layout engine needs to be initialized here so that the visualNodes and the visualLines dictionaries are populated 
-          InitializeLayout();
-          Repaint();
-        }
+        Repaint();
       }
     }
@@ -128,7 +129,16 @@
       if (this.Width <= 1 || this.Height <= 1)
         this.image = new Bitmap(1, 1);
-      else
+      else {
         this.image = new Bitmap(Width, Height);
+      }
       this.Repaint();
+    }
+
+    public event EventHandler Repainted;//expose this event to notify the parent control that the tree was repainted
+    protected virtual void OnRepaint(object sender, EventArgs e) {
+      var repainted = Repainted;
+      if (repainted != null) {
+        repainted(sender, e);
+      }
     }
 
@@ -137,4 +147,5 @@
         this.GenerateImage();
         this.Refresh();
+        OnRepaint(this, EventArgs.Empty);
       }
     }
@@ -147,4 +158,9 @@
           foreach (var visualNode in visualTreeNodes.Values) {
             DrawTreeNode(graphics, visualNode);
+            if (visualNode.Content.SubtreeCount > 0) {
+              foreach (var visualSubtree in visualNode.Content.Subtrees.Select(s => visualTreeNodes[s])) {
+                DrawLine(graphics, visualNode, visualSubtree);
+              }
+            }
           }
         }
@@ -170,5 +186,5 @@
         graphics.Clear(backgroundColor);
         if (tree != null) {
-          DrawFunctionTree(tree, graphics, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
+          DrawFunctionTree(graphics, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
         }
       }
@@ -236,5 +252,4 @@
 
     private void SymbolicExpressionTreeChart_MouseMove(object sender, MouseEventArgs e) {
-
       VisualTreeNode<ISymbolicExpressionTreeNode> visualTreeNode = FindVisualSymbolicExpressionTreeNodeAt(e.X, e.Y);
       if (draggedSymbolicExpressionTree != null &&
@@ -262,10 +277,16 @@
     #endregion
 
-    private void InitializeLayout() {
-      var actualRoot = tree.Root.SubtreeCount == 1 ? tree.Root.GetSubtree(0) : tree.Root;
-      layoutEngine.Initialize(actualRoot, n => n.Subtrees, n => n.GetLength(), n => n.GetDepth());
-      layoutEngine.CalculateLayout(this.Width, this.Height);
-      var visualNodes = layoutEngine.GetVisualNodes().ToList();
-      //populate the visual nodes and visual connections dictionaries
+    private void CalculateLayout(int preferredWidth, int preferredHeight, int minHDistance, int minVDistance) {
+      layoutEngine.NodeWidth = preferredWidth;
+      layoutEngine.NodeHeight = preferredHeight;
+      layoutEngine.HorizontalSpacing = minHDistance;
+      layoutEngine.VerticalSpacing = minVDistance;
+
+      var actualRoot = tree.Root;
+      if (actualRoot.Symbol is ProgramRootSymbol && actualRoot.SubtreeCount == 1) {
+        actualRoot = tree.Root.GetSubtree(0);
+      }
+
+      var visualNodes = layoutEngine.CalculateLayout(actualRoot, Width, Height).ToList();
       visualTreeNodes = visualNodes.ToDictionary(x => x.Content, x => x);
       visualLines = new Dictionary<Tuple<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>, VisualTreeNodeConnection>();
@@ -278,16 +299,10 @@
 
     #region methods for painting the symbolic expression tree
-    private void DrawFunctionTree(ISymbolicExpressionTree symbExprTree, Graphics graphics, int preferredWidth, int preferredHeight, int minHDistance, int minVDistance) {
-      //we assume here that the layout has already been initialized when the symbolic expression tree was changed
-      //recalculate layout according to new node widths and spacing
-      layoutEngine.NodeWidth = preferredWidth;
-      layoutEngine.NodeHeight = preferredHeight;
-      layoutEngine.HorizontalSpacing = minHDistance;
-      layoutEngine.VerticalSpacing = minVDistance;
-      layoutEngine.CalculateLayout(Width, Height);
+    private void DrawFunctionTree(Graphics graphics, int preferredWidth, int preferredHeight, int minHDistance, int minVDistance) {
+      CalculateLayout(preferredWidth, preferredHeight, minHDistance, minVDistance);
       var visualNodes = visualTreeNodes.Values;
       //draw nodes and connections
       foreach (var visualNode in visualNodes) {
-        DrawTreeNode(visualNode);
+        DrawTreeNode(graphics, visualNode);
         var node = visualNode.Content;
         foreach (var subtree in node.Subtrees) {
@@ -302,12 +317,4 @@
           }
         }
-      }
-    }
-
-    protected void DrawTreeNode(VisualTreeNode<ISymbolicExpressionTreeNode> visualTreeNode) {
-      using (var graphics = Graphics.FromImage(image)) {
-        graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.High;
-        graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
-        DrawTreeNode(graphics, visualTreeNode);
       }
     }
@@ -333,4 +340,15 @@
       }
     }
+
+    protected void DrawLine(Graphics graphics, VisualTreeNode<ISymbolicExpressionTreeNode> startNode, VisualTreeNode<ISymbolicExpressionTreeNode> endNode) {
+      var origin = new Point(startNode.X + startNode.Width / 2, startNode.Y + startNode.Height);
+      var target = new Point(endNode.X + endNode.Width / 2, endNode.Y);
+      graphics.Clip = new Region(new Rectangle(Math.Min(origin.X, target.X), origin.Y, Math.Max(origin.X, target.X), target.Y));
+      var visualLine = GetVisualSymbolicExpressionTreeNodeConnection(startNode.Content, endNode.Content);
+      using (var linePen = new Pen(visualLine.LineColor)) {
+        linePen.DashStyle = visualLine.DashStyle;
+        graphics.DrawLine(linePen, origin, target);
+      }
+    }
     #endregion
     #region save image
@@ -348,5 +366,5 @@
       Image image = new Bitmap(Width, Height);
       using (Graphics g = Graphics.FromImage(image)) {
-        DrawFunctionTree(tree, g, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
+        DrawFunctionTree(g, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
       }
       image.Save(filename);
@@ -358,5 +376,5 @@
         using (Metafile file = new Metafile(filename, g.GetHdc())) {
           using (Graphics emfFile = Graphics.FromImage(file)) {
-            DrawFunctionTree(tree, emfFile, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
+            DrawFunctionTree(emfFile, preferredNodeWidth, preferredNodeHeight, minHorizontalDistance, minVerticalDistance);
           }
         }
@@ -377,5 +395,7 @@
 
     private void reingoldTilfordToolStripMenuItem_Click(object sender, EventArgs e) {
-      layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode> {
+      minHorizontalDistance = 30;
+      minVerticalDistance = 30;
+      layoutEngine = new ReingoldTilfordLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees) {
         NodeWidth = preferredNodeWidth,
         NodeHeight = preferredNodeHeight,
@@ -383,10 +403,13 @@
         VerticalSpacing = minVerticalDistance
       };
-      InitializeLayout();
+      reingoldTilfordToolStripMenuItem.Checked = true;
+      boxesToolStripMenuItem.Checked = false;
       Repaint();
     }
 
     private void boxesToolStripMenuItem_Click(object sender, EventArgs e) {
-      layoutEngine = new BoxesLayoutEngine<ISymbolicExpressionTreeNode> {
+      minHorizontalDistance = 5;
+      minVerticalDistance = 5;
+      layoutEngine = new BoxesLayoutEngine<ISymbolicExpressionTreeNode>(n => n.Subtrees, n => n.GetLength(), n => n.GetDepth()) {
         NodeWidth = preferredNodeWidth,
         NodeHeight = preferredNodeHeight,
@@ -394,5 +417,6 @@
         VerticalSpacing = minVerticalDistance
       };
-      InitializeLayout();
+      reingoldTilfordToolStripMenuItem.Checked = false;
+      boxesToolStripMenuItem.Checked = true;
       Repaint();
     }
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs	(revision 11009)
@@ -52,8 +52,9 @@
       // textBox
       // 
-      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.textBox.BackColor = System.Drawing.Color.White;
+      this.textBox.Font = new System.Drawing.Font("Consolas", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.textBox.Location = new System.Drawing.Point(3, 30);
       this.textBox.Multiline = true;
@@ -66,6 +67,6 @@
       // formattersComboBox
       // 
-      this.formattersComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.formattersComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.formattersComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.formattersComboBox.FormattingEnabled = true;
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/LinearInstruction.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/LinearInstruction.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/LinearInstruction.cs	(revision 11009)
@@ -25,5 +25,5 @@
   public class LinearInstruction : Instruction {
     public double value;
-    public byte childIndex;
+    public int childIndex;
     public bool skip;
   }
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeLinearCompiler.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeLinearCompiler.cs	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeLinearCompiler.cs	(revision 11009)
@@ -34,5 +34,5 @@
           code[c + j] = new LinearInstruction { dynamicNode = s, nArguments = (byte)s.SubtreeCount, opCode = opCodeMapper(s) };
         }
-        code[i].childIndex = (byte)c;
+        code[i].childIndex = c;
         c += node.SubtreeCount;
         ++i;
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 11008)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 11009)
@@ -140,4 +140,6 @@
     <Compile Include="Interfaces\ISymbolicExpressionGrammarBase.cs" />
     <Compile Include="Interfaces\ISymbolicExpressionTreeGrammar.cs" />
+    <Compile Include="Interfaces\ISymbolicExpressionTreeNodeComparer.cs" />
+    <Compile Include="Interfaces\ISymbolicExpressionTreeNodeSimilarityComparer.cs" />
     <Compile Include="Interfaces\Operators\ISymbolicExpressionTreeArchitectureAlteringOperator.cs" />
     <Compile Include="Interfaces\Operators\ISymbolicExpressionTreeGrammarBasedOperator.cs" />
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeComparer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeComparer.cs	(revision 11009)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeComparer.cs	(revision 11009)
@@ -0,0 +1,5 @@
+﻿using System.Collections.Generic;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  public interface ISymbolicExpressionTreeNodeComparer : IComparer<ISymbolicExpressionTreeNode> { }
+}
Index: /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeSimilarityComparer.cs
===================================================================
--- /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeSimilarityComparer.cs	(revision 11009)
+++ /branches/DataPreprocessing/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNodeSimilarityComparer.cs	(revision 11009)
@@ -0,0 +1,10 @@
+﻿using System.Collections.Generic;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  public interface ISymbolicExpressionTreeNodeSimilarityComparer : IEqualityComparer<ISymbolicExpressionTreeNode>, IItem {
+    bool MatchConstantValues { get; set; }
+    bool MatchVariableWeights { get; set; }
+    bool MatchVariableNames { get; set; }
+  }
+}
